/*  GTKtalog.
 *  Copyright (C) 1999  Mathieu VILLEGAS
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef WHAT_DO_YOU_WANT_H__
#define WHAT_DO_YOU_WANT_H__

#include <gtk/gtk.h>
#include "data.h"

GtkWidget *window;
GtkWidget *clist;
GtkWidget *tree;

typedef struct
{
  gboolean scanned;
  gchar *path;
  Folder *folder;
} DirNode;

GtkWidget *create_tree (void);

void clear_all(GtkWidget *w, gpointer data);
void resolve_link(Folder *folder,char *link_path, char *cur_path, int i);

void fast_save(GtkWidget *w, gpointer data);
void open_cat(GtkWidget *w, gpointer data);
void save_cat(GtkWidget *w, gpointer data);
void quit_prog(GtkWidget *w, gpointer data);



#endif
